import React, { ReactElement, CSSProperties } from "react";
import { DragStart, DragUpdate, DropResult, ResponderProvided } from "react-beautiful-dnd";
interface Location {
    id: string;
    index: number;
}
export interface DragAndDropResult {
    source: Location;
    destination: Location;
}
export interface Chunk {
    id: string;
    items: any[];
}
export interface Props {
    chunks: Chunk[];
    direction: "horizontal" | "vertical";
    render(item: any): ReactElement<{}>;
    onDragStart?: (initial: DragStart, provided: ResponderProvided) => void;
    onDragUpdate?: (initial: DragUpdate, provided: ResponderProvided) => void;
    onDragEnd(result: DragAndDropResult): void;
    onDragEndNative?: (result: DropResult) => void;
    isDragDisabled?: boolean;
    containerStyles?: CSSProperties;
    gap?: number;
    ref?: any;
}
export declare const DragAndDropWrapper: React.FC<Props>;
export {};
