"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DragAndDropWrapper = void 0;
var react_1 = __importDefault(require("react"));
var react_beautiful_dnd_1 = require("react-beautiful-dnd");
var ListManagerItem_1 = require("./ListManagerItem");
var object_hash_1 = __importDefault(require("object-hash"));
var horizontalStyle = {
    display: "flex",
    flexDirection: "row",
    alignItems: "flex-start"
};
exports.DragAndDropWrapper = function (props) {
    var onDragEnd = props.onDragEnd, onDragEndNative = props.onDragEndNative, onDragStart = props.onDragStart, onDragUpdate = props.onDragUpdate, chunks = props.chunks, direction = props.direction, render = props.render, isDragDisabled = props.isDragDisabled, containerStyles = props.containerStyles, gap = props.gap, ref = props.ref;
    return (react_1.default.createElement(react_beautiful_dnd_1.DragDropContext, { onDragEnd: function (result) {
            mapAndInvoke(onDragEnd);
            onDragEndNative && onDragEndNative(result);
        }, onDragStart: onDragStart, onDragUpdate: onDragUpdate, ref: ref }, chunks.map(function (_a) {
        var droppableId = _a.id, items = _a.items;
        return (react_1.default.createElement(react_beautiful_dnd_1.Droppable, { key: droppableId, droppableId: droppableId, direction: direction }, function (provided, _) { return (react_1.default.createElement("div", __assign({ ref: provided.innerRef, style: direction === "horizontal" ? __assign(__assign(__assign({}, horizontalStyle), containerStyles), { gap: gap }) : containerStyles }, provided.droppableProps),
            items.map(function (item, index) { return (react_1.default.createElement("div", { style: { marginBottom: gap } },
                react_1.default.createElement(ListManagerItem_1.ListManagerItem, { key: object_hash_1.default(item), item: item, index: index, render: render, isDragDisabled: isDragDisabled }))); }),
            provided.placeholder)); }));
    })));
};
function mapAndInvoke(onDragEnd) {
    return function (_a) {
        var source = _a.source, destination = _a.destination;
        if (destination !== undefined && destination !== null) {
            var result = {
                source: {
                    id: source.droppableId,
                    index: source.index
                },
                destination: {
                    id: destination.droppableId,
                    index: destination.index
                }
            };
            onDragEnd(result);
        }
    };
}
